/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package kry;

import java.io.File;
import java.io.IOException;
import java.math.BigInteger;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;

/**
 *
 * @author Vladimir Vesely
 */
public class Vlakno extends Thread {
    KRYView GUI;
    public Vlakno() {
        super();
    }
    public Vlakno(KRYView a){
        GUI = a;
    }

    @Override public void run() {
        GUI.statusMessageLabel.setText("Provádím zakódování...");
        GUI.busyIconTimer.start();
        GUI.BUT_encode.setEnabled(false);
        GUI.BUT_decode.setEnabled(false);
        int k = 0, v = 0;
        VlaknoData[] vlak = new VlaknoData[GUI.vstup.getHeight()*GUI.vstup.getWidth()];
        for (int i = 0; i < GUI.vstup.getHeight(); i++) {
            for (int j = 0; j < GUI.vstup.getWidth(); j++) {
                vlak[v] = new VlaknoData(GUI, j, i, k);
                vlak[v].start();
                if (k++ == GUI.bitovepole.length()) k = 0;
                v++;
                GUI.progressBar.setValue(GUI.vstup.getHeight()*i + j);
            }
        }
        //pockame na dokonceni operaci vsech vlaken
        for (int i = 0; i < vlak.length; i++) {
            try {vlak[i].join();}
            catch (InterruptedException ex) { System.err.println("Chyba vlakna!"); }
        }
        //vytvoreni hashe
        String ret = GUI.vratRetezec(GUI.vystup);
        MessageDigest m;
        try {
            m = MessageDigest.getInstance("MD5");
            m.update(ret.getBytes(),0,ret.length());
            GUI.TXT_MD5.setText(new BigInteger(1,m.digest()).toString(16));
        } catch (NoSuchAlgorithmException ex) { System.err.println("Chyba MD5 hashishe!"); }
        //uvolneni GUI
        GUI.IMG_obrazek2.setImage(GUI.vystup);
        GUI.IMG_obrazek2.repaint();
        GUI.busyIconTimer.stop();
        GUI.statusAnimationLabel.setIcon(GUI.idleIcon);
        GUI.BUT_encode.setEnabled(true);
        GUI.BUT_decode.setEnabled(true);
        try {
            ImageIO.write(GUI.vystup, "bmp", new File(GUI.soubor + "_tajemstvi.bmp"));
            GUI.statusMessageLabel.setText("Hotovo! Výsledek uložen do: " + GUI.soubor + "_tajemstvi.bmp");
        } catch (IOException ex) {
            System.err.println("Chyba pri ukladani souboru!");
        }

    }
}
